using UnityEngine;
using Zenject;

namespace Sources.Gui
{
    public class ResearchPanel : MonoBehaviour
    {
        [SerializeField] private ResearchButton _healthModuleButton;
        [SerializeField] private ResearchButton _swordMasteryButton;
        [SerializeField] private ResearchButton _weaponModuleButton;
        [SerializeField] private ResearchButton _regenerationModuleButton;
        [SerializeField] private ResearchButton _gunPower;
        [SerializeField] private ResearchButton _gunSpeed;
        [SerializeField] private ResearchButton _gunBulletSpeed;
        [SerializeField] private ResearchButton _swordDancer;

        [Inject] private Player _player;

        private void Start()
        {
            // unlockLevel, maxLevel, price, title, value, dependsOn = null
        
            _healthModuleButton.Setup(1, 5, 1, "Health Module", "Increases your avatar's health capacity", _player.HpLevel);
            _regenerationModuleButton.Setup(1, 10, 1, "Regeneration Module", "Increases amount of health healed per second", _player.Regeneration, _healthModuleButton);
        
            _swordMasteryButton.Setup(1, 5, 1, "Sword Mastery", "Increases swords damage", _player.SwordMastery);
            _swordDancer.Setup(1, 1, 1, "Blade Dancer", "Adds second sword", _player.SwordDancer, _swordMasteryButton);
        
            _weaponModuleButton.Setup(3, 1, 1, "Weapon Module", "Installs special weapon module which allows you to use ranged attack using [RMB]", _player.WeaponModule);
            _gunPower.Setup(1, 5, 1, "Weapon Power Module", "Increases ranged weapon damage", _player.WeaponPower, _weaponModuleButton);
            _gunSpeed.Setup(1, 10, 1, "Weapon Cooler", "Improved cooling system allows avatar to shoot faster", _player.WeaponCooldown, _weaponModuleButton);
            _gunBulletSpeed.Setup(1, 10, 1, "Plasma Accelerator", "Increases speed of plasma shot out of your weapon", _player.PlasmaAccelerator, _weaponModuleButton);
        }
    }
}